<script lang="ts" setup name="ListSource">
import { reactive, ref } from 'vue'
import type { Ref } from 'vue'
import { ElLoading, ElMessage, ElMessageBox } from 'element-plus'
import type { IlistQuery, IlistType } from '../list_interface'
import { getSoucreList, getSoucreListDelete } from '@/api/measure/source'
import { uploadApi } from '@/api/system/notice'
import { exportExcel } from '@/utils/exportXlsx'
const props = defineProps({
  name: {
    type: String,
    default: '全部',
  },
  buttoms: {
    type: Array,
    default: () => [],
  },
})
const emit = defineEmits(['setData']) // 关闭
// 查询条件
const listQuery: Ref<IlistQuery> = ref({
  supplierNo: '', // 业务内容
  supplierName: '', // 溯源供方名称
  businessContent: '', // 溯源供方编号
  offset: 1,
  limit: 10,
})
// 初始化路由
const $router = useRouter()
// 控制是否显示新增页面
const show = ref(true)
// 表格数据
const list = ref([
  { name: '张飒' },
])
// 总数
const total = ref(0)
// 表头
const columns = ref([
  {
    text: '申请编号',
    value: 'name',
    align: 'center',
  },
  {
    text: '申请类型',
    value: 'name',
    width: '120',
    align: 'center',
  },
  {
    text: '标准代码',
    value: 'name',
    align: 'center',
  },
  {
    text: '标准名称',
    value: 'name',
    align: 'center',
  },
  {
    text: '标准所在部门',
    value: 'name',
    width: '110',
    align: 'center',
  },
  {
    text: '负责人',
    value: 'name',
    align: 'center',
  },
  {
    text: '申请部门',
    value: 'name',
    align: 'center',
  },
  {
    text: '申请人',
    value: 'name',
    align: 'center',
  },
  {
    text: '申请时间',
    value: 'name',
    align: 'center',
  },
  {
    text: '审批状态',
    value: 'name',
    align: 'center',
  },
])
// 审批弹窗信息收集类型
interface applyListType {
  select: string
  epilog: string
  approval: string
  approvalTime: string
}
// 审批弹窗信息收集
const applyList = ref<applyListType>({
  select: '',
  epilog: '',
  approval: '',
  approvalTime: '',
})
const buttonArray = ref<string[]>([])
// 选中的内容
const checkoutList = ref([])
// 文件上传input
const fileRef = ref()
// 审批弹窗开关
const applyShow = ref(false)
// 删除id
const deleteId = ref('')
// 详情id
const infoId = ref('0')
// 点击按钮
const buttonType = ref('')
const standardManagerStateList = ref([
  { name: '张三', id: '1', value: '1' },
  { name: '李四', id: '2', value: '5' },
  { name: '王五', id: '3', value: '7' },
  { name: '赵六', id: '4', value: '2' },
])
const loadingTable = ref(false)
const fetchData = (isNowPage: boolean) => {
  loadingTable.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.value.offset = 1
  }
  getSoucreList(listQuery.value).then((response) => {
    list.value = response.data.rows
    total.value = parseInt(response.data.total)
    loadingTable.value = false
  })
}
// 多选发生改变时
const handleSelectionChange = (e: any) => {
  checkoutList.value = e
}
// 点击删除和编辑的参数类型
interface rowReturn {
  id: string
  name: string
}
// 点击删除
const handleDelete = (row: rowReturn, type: string) => {
  ElMessageBox.confirm(
    `确认${type}${row.name}吗？`,
    '提示',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  )
    .then(() => {
      // getSoucreListDelete({ id: row.id as string }).then((res) => {
      //   if (res.code === 200) {
      //     ElMessage({
      //       type: 'success',
      //       message: '删除成功',
      //     })
      //     fetchData(true)
      //   }
      // })
    })
}
// // 点击编辑/详情
// const handleEdit = (index: string, row: rowReturn, value: string) => {
//   if (value === '查看' || value === '编辑') {
//     buttonArray.value = ['同意', '驳回', '拒绝']
//     buttonType.value = value
//     infoId.value = row.id
//     show.value = false
//   }
//   else if (value === '删除' || value === '取消' || value === '提交') {
//     handleDelete(row, value)
//   }
//   else {
//     if (value === '同意') {
//       applyList.value.select = '1'
//     }
//     else if (value === '驳回') {
//       applyList.value.select = '2'
//     }
//     else {
//       applyList.value.select = '3'
//     }
//     applyList.value.approval = row.name
//     applyList.value.approvalTime = row.name
//     applyShow.value = true
//   }
// }
const pageTypeMap = ref('')
// 点击每条数据操作
const handleEdit = (row: rowReturn, pageType: string) => {
  if (pageType === '编辑' || pageType === '查看') {
    pageTypeMap.value = pageType === '编辑' ? 'edit' : 'detail'
    $router.push(`/maintenance/${pageTypeMap.value}/${row.id}`)
  }
  else if (pageType === '同意' || pageType === '驳回' || pageType === '拒绝') {
    if (pageType === '同意') {
      applyList.value.select = '1'
    }
    else if (pageType === '驳回') {
      applyList.value.select = '2'
    }
    else {
      applyList.value.select = '3'
    }
    applyList.value.approval = row.name
    applyList.value.approvalTime = row.name
    applyShow.value = true
  }
  else {
    handleDelete(row, pageType)
  }
}
// 审批弹窗关闭
const handleClose = () => {
  applyShow.value = false
}
// 点击搜索
const searchList = () => {
}
const cancelEvent = () => {
  console.log('cancel!')
}
// 点击重置
const clearList = () => {
  listQuery.value = {
    supplierNo: '', // 业务内容
    supplierName: '', // 溯源供方名称
    businessContent: '', // 溯源供方编号
    offset: 1,
    limit: 20,
  }
}
// 关闭编辑
const close = () => {
  show.value = true
}
// 导出
const exportExcelBtn = () => {
  const loading = ElLoading.service({
    lock: true,
    text: 'Loading',
    background: 'rgba(255, 255, 255, 0.8)',
  })
  if (checkoutList.value.length <= 0) {
    exportExcel({
      json: list.value.map((item: IlistType, index: number) => ({ index: index + 1, supplierNo: item.supplierNo, supplierName: item.supplierName, businessContent: item.businessContent, briefName: item.briefName, director: item.director, mobile: item.mobile, companyCity: item.companyCity, createTime: item.createTime, remark: item.remark })),
      name: '溯源供方',
      titleArr: ['序号', '溯源供方编号', '溯源供方名称', '业务内容', '业务资质', '负责人', '联系方式', '地址', '创建时间', '备注'],
      sheetName: 'sheet1',
    })
  }
  else {
    exportExcel({
      json: checkoutList.value.map((item: IlistType, index: number) => ({ index: index + 1, supplierNo: item.supplierNo, supplierName: item.supplierName, businessContent: item.businessContent, briefName: item.briefName, director: item.director, mobile: item.mobile, companyCity: item.companyCity, createTime: item.createTime, remark: item.remark })),
      name: '溯源供方',
      titleArr: ['序号', '溯源供方编号', '溯源供方名称', '业务内容', '业务资质', '负责人', '联系方式', '地址', '创建时间', '备注'],
      sheetName: 'sheet1',
    })
  }
  loading.close()
}
// 上传文件/批量导入
const onFileChange = (event: any) => {
  if (event.target.files[0].type === 'application/pdf') {
    if (event.target.files?.length !== 0) {
      // 创建formdata对象
      const fd = new FormData()
      fd.append('multipartFile', event.target.files[0])
      uploadApi(fd).then((res) => {
        if (res.code === 200) {
          ElMessage.success('上传成功')
        }
        else {
          ElMessage.error(res.message)
        }
      })
    }
  }
  else {
    ElMessage.error('请上传pdf格式')
  }
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    listQuery.value.limit = val.size
  }
  if (val && val.page) {
    listQuery.value.offset = val.page
  }
  fetchData(true)
}
const upload = () => {
  fileRef.value.click()
}
const uploadAll = () => {
  upload()
}
const add = () => {
  $router.push('/maintenance/add')
}
const exportAll = () => {
  exportExcelBtn()
}
watch(() => show.value, (newVal) => {
// 变化后存储
  emit('setData', newVal)
},
{ deep: true, immediate: true })
// 打印
const printObj = ref({
  id: 'print', // 需要打印元素的id
  popTitle: '溯源供方编号模板', // 打印配置页上方的标题
  extraHead: '', // 最上方的头部文字，附加在head标签上的额外标签，使用逗号分割
  preview: false, // 是否启动预览模式，默认是false
  standard: '',
  extarCss: '',
})
// 审批弹窗的提交
const applyListSubmit = () => {
  console.log(applyList.value)
  if (applyList.value.select == '') {
    return ElMessage.error('必须选择审批意见')
  }
  handleClose()
}
</script>

<template>
  <div v-if="show">
    <app-container>
      <search-area
        :need-clear="true"
        @search="searchList" @clear="clearList"
      >
        <search-item style="width: 15%;">
          <el-input
            v-model.trim="listQuery.supplierNo"
            placeholder="申请编号"
            clearable
          />
        </search-item>
        <search-item style="width: 15%;">
          <el-input
            v-model.trim="listQuery.supplierName"
            placeholder="设备编号"
            clearable
          />
        </search-item>
        <search-item style="width: 15%;">
          <el-input
            v-model.trim="listQuery.businessContent"
            placeholder="标准代码"
            clearable
          />
        </search-item>
        <search-item style="width: 15%;">
          <el-input
            v-model.trim="listQuery.businessContent"
            placeholder="标准名称"
            clearable
          />
        </search-item>
        <search-item style="width: 15%;">
          <el-select
            v-model.trim="listQuery.businessContent"
            clearable
            placeholder="申请部门"
            size="default"
          >
            <el-option
              v-for="item in standardManagerStateList"
              :key="item.id"
              :label="item.name"
              :value="item.value"
            />
          </el-select>
        </search-item>
        <search-item style="width: 15%;">
          <el-select
            v-model.trim="listQuery.businessContent"
            clearable
            placeholder="申请状态"
            size="default"
          >
            <el-option
              v-for="item in standardManagerStateList"
              :key="item.id"
              :label="item.name"
              :value="item.value"
            />
          </el-select>
        </search-item>
      </search-area>
      <table-container>
        <template #btns-right>
          <icon-button icon="icon-add" title="新建" type="primary" @click="add" />
          <icon-button icon="icon-export" title="导出" type="primary" @click="exportAll" />
          <icon-button v-print="printObj" icon="icon-print" title="打印" type="primary" />
        </template>
        <input v-show="false" ref="fileRef" type="file" accept="pdf/*" @change="onFileChange">
        <normal-table
          :data="list" :total="total" :columns="columns" :query="listQuery"
          :list-loading="loadingTable" is-showmulti-select @change="changePage" @multiSelect="handleSelectionChange"
        >
          <template #columns>
            <el-table-column label="操作" align="center" width="300">
              <template #default="{ row }">
                <el-button
                  v-for="(item, index) in buttoms"
                  :key="index"
                  size="small"
                  :type="item.type" link
                  @click="handleEdit(row, item.name)"
                >
                  {{ item.name }}
                </el-button>
              </template>
            </el-table-column>
          </template>
        </normal-table>
      </table-container>
    </app-container>
  </div>
  <el-dialog
    v-model="applyShow"
    title="审批操作"
    width="50%"
    :before-close="handleClose"
  >
    <el-form
      ref="addPersonListForm"
      label-position="left"
      label-width="100px"
      :model="applyList"
    >
      <el-row :gutter="24">
        <el-col :span="24">
          <el-form-item label="审批意见:">
            <el-radio-group v-model="applyList.select" class="ml-4">
              <el-radio label="1" size="large">
                同意
              </el-radio>
              <el-radio label="2" size="large">
                驳回
              </el-radio>
              <el-radio label="3" size="large">
                拒绝
              </el-radio>
            </el-radio-group>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row :gutter="24">
        <el-col :span="24">
          <el-form-item label="审批结论:">
            <el-input
              v-model="applyList.epilog"
              :rows="4"
              show-word-limit
              type="textarea"
            />
          </el-form-item>
        </el-col>
      </el-row>
      <el-row :gutter="24">
        <el-col :span="12">
          <el-form-item label="审批人:">
            <el-input
              v-model="applyList.approval"
              placeholder="审批人"
              disabled
            />
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="审批时间:">
            <el-input
              v-model="applyList.approvalTime"
              style="width: 100%;"
              placeholder="审批时间"
              disabled
            />
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>
    <template #footer>
      <el-button type="primary" @click="applyListSubmit">
        提交
      </el-button>
      <el-button type="info" @click="handleClose">
        取消
      </el-button>
    </template>
  </el-dialog>
</template>
